package com.emato.ccnet.wx.biz.req.order.csp;

import com.emato.ccnet.wx.biz.CebReqGetDate;
import com.emato.ccnet.wx.contants.CcnetContants;
import com.emato.ccnet.wx.dao.entity.ccnet.WxOrder;
import com.emato.ccnet.wx.dto.ccnetdto.OrderBill;
import com.emato.ccnet.wx.service.WxOrderService;
import com.google.common.collect.ImmutableMap;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Map;

@Component
@Transactional(value = "primaryTransactionManager")
public class Ceb311OrderGetDate implements CebReqGetDate {

    @Autowired
    private WxOrderService wxOrderService;
    /**
     * 获取weimob数据并更新状态
     * @param param
     * @return
     */
    @Override
    public List getData(Map<String, Object> param) {
        //取电子订单数据
        List<WxOrder> list = wxOrderService.getWxOrder(param);
        if (list == null || list.size() == 0) {
            return Collections.emptyList();
        }

        //更新取出电子订单数据状态
        List<Map<String, Object>> updateList = new ArrayList<>();
        list.stream().forEach(x->{
            Map<String, Object> map = ImmutableMap.of("orderSn", x.getOrderSn(),  "clecOrderStatus", CcnetContants.sendStatus.item_1.getItem());
            updateList.add(map);
        });
        if (updateList.size() > 0) {
            wxOrderService.updateWxOrderStatusBatch(updateList);
        }
        return list;
    }
}
