package com.emato.ccnet.wx.biz.req.play.wx;

import com.emato.ccnet.wx.biz.CebReqAddDate;
import com.emato.ccnet.wx.service.WxPayDocService;
import com.emato.ccnet.wx.support.msg.resp.ResponseMessage;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;

@Component
public class WxplayAddDate implements CebReqAddDate {
    private static final Logger LOGGER = LoggerFactory.getLogger(WxplayAddDate.class);
    @Autowired
    private WxPayDocService wxPayDocService;

    /**
     * 批量增加记录
     * @param list
     * @return
     */
    @Override
    public ResponseMessage addDate(List list) {
        //初始化批量支付单记录新增
        int addCuspayment = wxPayDocService.addWxPayDoc(list);
        if(addCuspayment <= 0){
            String info = "初始化批量支付单记录新增失败";
            LOGGER.error("--- {}", info);
            return ResponseMessage.failed();
        }
        return ResponseMessage.success();
    }
}
