package com.emato.ccnet.wx.biz.req.play.wx;

import com.emato.ccnet.wx.biz.CebReqBiz;
import com.emato.ccnet.wx.contants.CcnetContants;
import com.emato.ccnet.wx.support.msg.resp.ResponseMessage;
import com.google.common.collect.ImmutableMap;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

import java.util.Collections;
import java.util.List;
import java.util.Map;

/**
 * 支付单业务逻辑处理
 */
@Component
public class WxplayBiz implements CebReqBiz {
    private static final Logger LOGGER = LoggerFactory.getLogger(WxplayBiz.class);
    private Map<String, Object> param = Collections.EMPTY_MAP;

    @Autowired
    private WxplayOrderGetDate wxplayOrderGetDate;

    @Autowired
    private WxplayAddDate wxplayAddDate;

    @Autowired
    private WxplaySendDateRequet wxplaySendDateRequet;

    @Value("${db.ccnet-send-wm.page-size}")
    private String limit = "20";
    /**
     * 支付单正常业务入口
     * @return
     */
    @Override
    public ResponseMessage biz() {

        Map<String,Object> reqParam = ImmutableMap.of("number", Integer.valueOf(limit),"wxOrderDetail", CcnetContants.isscan.item_1.getItem(),"playOrderStatus", CcnetContants.sendStatus.item_0.getItem());
        //查询中网支付单数据
        List list = wxplayOrderGetDate.getData(reqParam);
        if (list.isEmpty()) {
            String info = "没有待发送数据, 生成海关支付单报文提前结束";
            LOGGER.error("--- {}", info);
            return ResponseMessage.failed(info);
        }

        //添加支付单数据
        ResponseMessage responseMessage = wxplayAddDate.addDate(list);
        if(!ResponseMessage.isSuccess(responseMessage)){
            String info = "生成海关支付单初始化失败" + responseMessage.getMsg();
            LOGGER.error("--- {}", info);
            return ResponseMessage.failed(info);
        }

        //发送数据wx系统请求并响应更新订单
        ResponseMessage wxPlayResponseMessage = wxplaySendDateRequet.sendDate();
        if(!ResponseMessage.isSuccess(wxPlayResponseMessage)){
            String info = "发送请求响应失败"+wxPlayResponseMessage.getMsg();
            LOGGER.error("--- {}", wxPlayResponseMessage.getMsg());
            return ResponseMessage.failed(info);
        }

        return ResponseMessage.success();
    }

    public Map<String, Object> getParam() {
        return param;
    }

    public void setParam(Map<String, Object> param) {
        this.param = param;
    }

}
