package com.emato.ccnet.wx.biz.req.play.wx;

import com.emato.ccnet.wx.biz.CebReqGetDate;
import com.emato.ccnet.wx.contants.CcnetContants;
import com.emato.ccnet.wx.dao.entity.ccnet.WxOrder;
import com.emato.ccnet.wx.service.WxOrderService;
import com.google.common.collect.ImmutableMap;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Map;

@Component
@Transactional(value = "primaryTransactionManager")
public class WxplayOrderGetDate implements CebReqGetDate {
    private static final Logger LOGGER = LoggerFactory.getLogger(WxplayOrderGetDate.class);
    @Autowired
    private WxOrderService wxOrderService;

    /**
     * 获取weimob数据并更新状态
     * @param param
     * @return
     */
    @Override
    public List getData(Map<String, Object> param) {
        //取支付单数据
        List<WxOrder> list = wxOrderService.getWxOrder(param);
        if (list == null || list.size() == 0) {
            return Collections.emptyList();
        }

        //更新取出支付单状态
        List<Map<String, Object>> updateList = new ArrayList<>();
        list.stream().forEach(x->{
            Map<String, Object> map = ImmutableMap.of("orderSn", x.getOrderSn(), "playOrderStatus", CcnetContants.sendStatus.item_1.getItem());
            updateList.add(map);
        });
        if (updateList.size() > 0) {
            try {
                wxOrderService.updateWxOrderStatusBatch(updateList);
            } catch (Exception e) {
                e.printStackTrace();
                LOGGER.info("批量新增失败！");
                return null;
            }
        }
        return list;
    }
}
