package com.emato.ccnet.wx.biz.req.play.wx;

import com.emato.ccnet.wx.biz.CebReqSendDateAfter;
import com.emato.ccnet.wx.contants.Contants;
import com.emato.ccnet.wx.service.WxCuspayStatusService;
import com.emato.ccnet.wx.service.WxOrderService;
import com.google.common.collect.ImmutableMap;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

@Component
public class WxplaySendDateAfter implements CebReqSendDateAfter {
    private static final Logger LOGGER = LoggerFactory.getLogger(WxplaySendDateAfter.class);

    @Autowired
    private WxCuspayStatusService wxCuspayStatusService;

    @Autowired
    private WxOrderService wxOrderService;

    /**
     * 状态修改
     * @param sucList
     * @param failedList
     * @return
     */
    @Override
    public boolean afterSend(List<String> sucList, List<String> failedList) {
        List<Map<String, Object>> sucs = new ArrayList<>();
        List<Map<String, Object>> faileds = new ArrayList<>();
        List<Map<String, Object>> wxFaileds = new ArrayList<>();
        //全部处理完后
        if (sucList.size() > 0) {
            LOGGER.info("--- 【WxPlay】更新【成功】报文订单记录......");
            sucList.stream().forEach(x->{
                Map<String, Object> map = ImmutableMap.of("orderSn", x, "sendStatus", Contants.DECLARATION_SUCCESS_STATUS);
                sucs.add(map);
            });
            if(sucs.size() > 0){
                try {
                    wxCuspayStatusService.updatewxCuspayStatusServiceBatch(sucs);
                } catch (Exception e) {
                    String info = "【WxPlay】更新【成功】报文订单记录失败";
                    LOGGER.error("--- "+info, e);
                }
            }
        }

        if (failedList.size() > 0) {
            LOGGER.info("--- 【WxPlay】更新【失败】报文订单记录......");
            failedList.stream().forEach(x->{
                Map<String, Object> map = ImmutableMap.of("orderSn", x, "sendStatus", Contants.FAIL_STATUS);
                Map<String, Object> wxMap = ImmutableMap.of("orderSn", x, "playOrderStatus", Contants.FAIL_STATUS);
                faileds.add(map);
                wxFaileds.add(wxMap);
            });
            //ccnet中的支付订单修改为失败
            if (faileds.size() > 0) {
                try {
                    wxCuspayStatusService.updatewxCuspayStatusServiceBatch(faileds);
                } catch (Exception e) {
                    String info = "【WxPlay】更新【失败】报文订单记录失败";
                    LOGGER.error("--- {}", info,e);
                }
            }
            //kmall中的支付单修改为待发送
            if (wxFaileds.size() > 0) {
                try {
                    wxOrderService.updateWxOrderStatusBatch(wxFaileds);
                } catch (Exception e) {
                    String info = "【wmOrder】更新【失败】报文订单记录失败";
                    LOGGER.error("--- {}", info,e);
                }
            }
        }
        return true;
    }
}
