package com.emato.ccnet.wx.biz.req.waybill.oms;

import com.emato.ccnet.wx.biz.CebReqAddDate;
import com.emato.ccnet.wx.service.CusWaybillService;
import com.emato.ccnet.wx.support.msg.resp.ResponseMessage;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Component
@Transactional(value = "primaryTransactionManager")
public class Ceb511OmsWayAddDate implements CebReqAddDate {
    private static final Logger LOGGER = LoggerFactory.getLogger(Ceb511OmsWayAddDate.class);
    @Autowired
    private CusWaybillService cusWaybillService;
    /**
     * 添加运单数据
     * @param list
     * @return
     */
    @Override
    public ResponseMessage addDate(List list) {
        //运单数据的初始化
        int cusWaybill = cusWaybillService.addCusWaybill(list);
        if(cusWaybill != 1){
            String info = "初始化批量海关支付单记录新增失败";
            LOGGER.error("--- {}", info);
            return ResponseMessage.failed();
        }
        return ResponseMessage.success();
    }
}
