package com.emato.ccnet.wx.biz.req.waybill.oms;

import com.emato.ccnet.wx.biz.CebCustomsResponse;
import com.emato.ccnet.wx.contants.CcnetContants;
import com.emato.ccnet.wx.contants.Contants;
import com.emato.ccnet.wx.contants.SysContants;
import com.emato.ccnet.wx.contants.WmContants;
import com.emato.ccnet.wx.dao.entity.ccnet.*;
import com.emato.ccnet.wx.dto.ccnetdto.CbecOrderMerchantNotiReturnOrder;
import com.emato.ccnet.wx.dto.ccnetdto.PlayResponse;
import com.emato.ccnet.wx.dto.ccnetdto.WayBillResponse;
import com.emato.ccnet.wx.manager.result.Result;
import com.emato.ccnet.wx.manager.snow.SnowflakeUtil;
import com.emato.ccnet.wx.service.*;
import com.emato.ccnet.wx.support.msg.resp.ResponseMessage;
import com.emato.ccnet.wx.util.MapBeanUtil;
import com.emato.ccnet.wx.util.jackson.JacksonUtil;
import com.google.common.collect.ImmutableMap;
import com.google.gson.Gson;
import net.sf.json.JSONArray;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.*;

@Component
public class Ceb511Response {
    private static final Logger LOGGER = LoggerFactory.getLogger(Ceb511Response.class);

    @Autowired
    private CusWaybillStatusService cusWaybillStatusService;

    @Autowired
    private CusWaybillRespService cusWaybillRespService;

    @Autowired
    private CusWaybillService cusWaybillService;


    @Autowired
    private WxOrderService wxOrderService;

    @Autowired
    private WxOrderGrabService wxOrderGrabService;

    public ResponseMessage biz(Result result) {
        //解析数据
        WayBillResponse wayBillResponse = analysisResponse(result);

        CbecOrderMerchantNotiReturnOrder cbecOrderMerchantNotiReturnOrder = new CbecOrderMerchantNotiReturnOrder();
        cbecOrderMerchantNotiReturnOrder.setNotiId(wayBillResponse.getNotiId());
        List<CbecOrderMerchantNotiReturnOrder> cbecOrderMerchantNotiReturnOrderList = new ArrayList<>();
        cbecOrderMerchantNotiReturnOrderList.add(cbecOrderMerchantNotiReturnOrder);
        if(wayBillResponse == null){
            LOGGER.info("解析响应数据失败");
            return ResponseMessage.error("解析响应数据失败",cbecOrderMerchantNotiReturnOrderList);
        }

        CusWaybillResp cusOrderResp = InitWxCuspayRespData(wayBillResponse);
        if(cusOrderResp == null){
            return ResponseMessage.error("初始化数据失败",cbecOrderMerchantNotiReturnOrderList);
        }
        cusOrderResp.setBizInfoCode(result.getCode());
        cusOrderResp.setBizInfoDesc(result.getMsg());

        if(cusWaybillRespService.add(cusOrderResp) == null){
            String info = "新增回調数据失败";
            LOGGER.error("--- {}", info);
            return ResponseMessage.error(info,cbecOrderMerchantNotiReturnOrderList);
        }

        CusWaybill cusWaybill = cusWaybillService.getCusWaybillByMerchOrderSn(wayBillResponse.getMerchOrderSn());
        if(cusWaybill == null){
            String info = "查找运单数据失败";
            LOGGER.error("--- {}", info);
            return ResponseMessage.error(info,cbecOrderMerchantNotiReturnOrderList);
        }

        //查找订单状态表
        Map<String, Object> reqParam = ImmutableMap.of("cusWaybillSn", cusWaybill.getCusWaybillSn(),"sendStatus", Contants.DECLARATION_SUCCESS_STATUS);
        CusWaybillStatus cusWaybillStatus = cusWaybillStatusService.findCusWaybillStatus(reqParam);
        if(cusWaybillStatus == null){
            String info = "查找运单状态表失败";
            LOGGER.error("--- {}", info);
            return ResponseMessage.error(info,cbecOrderMerchantNotiReturnOrderList);
        }


        WxOrder wxOrder = wxOrderService.getWxOrderByOrderSn(cusWaybill.getMerchOrderId());
        if(wxOrder == null){
            String info = "查找运单数据失败";
            LOGGER.error("--- {}", info);
            return ResponseMessage.error(info,cbecOrderMerchantNotiReturnOrderList);
        }

        if(CcnetContants.notiType.item_00.getItem().equals(wayBillResponse.getNotiType())){

            cusWaybillStatus.setRespStatus(Contants.FAIL_STATUS);
            wxOrder.setPlayOrderStatus(WmContants.wmStatuses.item_3.getItem());
            Map<String, Object> wxMap = createWxOrderGrabMap(wayBillResponse);
            wxMap.put("orderSn",wxOrder.getOrderSn());
            wxMap.put("isCustomsSend",Contants.WX_FAIL);

            wxOrderGrabService.updateMallOrderProcessRecord(wxMap);

        }else if(CcnetContants.notiType.item_20.getItem().equals(wayBillResponse.getNotiType()) && CcnetContants.serviceStates.item_2.getItem().equals(wayBillResponse.getNotiStatus())){
            cusWaybillStatus.setRespStatus(Contants.INVET_SUCCESS);
            Map<String, Object> wxMap = createWxOrderGrabMap(wayBillResponse);
            wxMap.put("orderSn",wxOrder.getOrderSn());
            wxMap.put("isCustomsSend",Contants.WX_SUCC);
            wxOrderGrabService.updateMallOrderProcessRecord(wxMap);

            Map<String, Object> reMap = new HashMap<>();
            reMap.put("orderSn",wxOrder.getOrderSn());
            if(CcnetContants.wsFlag.item_10.getItem().equals(wxOrder.getWsFlag())){
                reMap.put("orderStatus","300");
                reMap.put("shippingStatus","1");
            }else {
                reMap.put("shippingNo",wayBillResponse.getLogisticsNo());
                reMap.put("shippingCode","YD");
                reMap.put("shippingName","韵达快递");
                reMap.put("orderStatus","300");
                reMap.put("shippingStatus","1");
            }
            wxOrderGrabService.updateBuyerPayCheck(reMap);

        }else if(CcnetContants.notiType.item_20.getItem().equals(wayBillResponse.getNotiType()) && CcnetContants.serviceStates.item_3.getItem().equals(wayBillResponse.getNotiStatus())){
            cusWaybillStatus.setRespStatus(Contants.FAIL_STATUS);
            Map<String, Object> wxMap = createWxOrderGrabMap(wayBillResponse);
            wxMap.put("orderSn",wxOrder.getOrderSn());
            wxMap.put("isCustomsSend",Contants.WX_FAIL);
            wxOrderGrabService.updateMallOrderProcessRecord(wxMap);

        }else if(CcnetContants.notiType.item_20.getItem().equals(wayBillResponse.getNotiType()) && CcnetContants.serviceStates.item_4.getItem().equals(wayBillResponse.getNotiStatus())){
            Map<String, Object> wxMap = createWxOrderGrabMap(wayBillResponse);
            wxMap.put("orderSn",wxOrder.getOrderSn());
            wxMap.put("isCustomsSend",Contants.WX_UNDERWAY);
            wxOrderGrabService.updateMallOrderProcessRecord(wxMap);
            if (wayBillResponse.getNotiInfo().contains("支付信息不存在") && wayBillResponse.getNotiInfo().contains("订单信息不存在")) {
                wxOrder.setPlayOrderStatus(CcnetContants.sendStatus.item_0.getItem());
                wxOrder.setClecOrderStatus(CcnetContants.sendStatus.item_0.getItem());
            }else if(wayBillResponse.getNotiInfo().contains("支付信息不存在") ){
                wxOrder.setPlayOrderStatus(CcnetContants.sendStatus.item_0.getItem());
            }else if(wayBillResponse.getNotiInfo().contains("订单信息不存在")){
                wxOrder.setClecOrderStatus(CcnetContants.sendStatus.item_0.getItem());
            }

        }else if(CcnetContants.notiType.item_40.getItem().equals(wayBillResponse.getNotiType())){
            cusWaybillStatus.setSendStatus(Contants.SUCCESS_STATUS);
            wxOrder.setPlayOrderStatus(WmContants.wmStatuses.item_2.getItem());
            cusWaybillStatus.setRespStatus(Contants.SUCCESS_STATUS);
            Map<String, Object> recordMap = ImmutableMap.of("orderSn", wxOrder.getOrderSn(), "shipmentStartTime",new Date());
            wxOrderGrabService.updateMallOrderProcessRecord(recordMap);

        }else{
            String info = "状态非法,无需处理";
            LOGGER.error("--- {}", info);
            return ResponseMessage.error(info,cbecOrderMerchantNotiReturnOrderList);
        }

        if(cusWaybillStatusService.update(cusWaybillStatus) == null){
            String info = "更新运单状态失败";
            LOGGER.error("--- {}", info);
            return ResponseMessage.error(info,cbecOrderMerchantNotiReturnOrderList);
        }

        wxOrderService.update(wxOrder);
        //回执给oms的数据
        String info = "oms处理回调成功";
        LOGGER.info(info);

        return ResponseMessage.success(info,cbecOrderMerchantNotiReturnOrderList);
    }

    private Map<String,Object> createWxOrderGrabMap(WayBillResponse wayBillResponse) {
        Map<String,Object> wxMap = new HashMap<>();
        wxMap.put("waybillStartTime",wayBillResponse.getWaybillStartTime());
        wxMap.put("waybillSuccTime",wayBillResponse.getWaybillEndTime());
        wxMap.put("customsStartTime",wayBillResponse.getClearStartTime());
        wxMap.put("customsSuccTime",wayBillResponse.getClearEndTime());
        wxMap.put("logisticsNo",wayBillResponse.getLogisticsNo());
        wxMap.put("invtNo",wayBillResponse.getInvtNo());
        return wxMap;
    }

    /**
     * 解析响应数据
     * @param result
     * @return
     */
    private static WayBillResponse analysisResponse(Result result) {
        Object dataResult = result.getData();
        if(dataResult == null){
            LOGGER.info("解析响应数据OrderResponse集合失败");
            return null;
        }

        JSONArray json = JSONArray.fromObject(dataResult);
        if(json == null && json.size() <= 0){
            return null;
        }

        WayBillResponse wayBillResponse = null;
        try {
            wayBillResponse =  JacksonUtil.fromStringJson(json.getString(0),WayBillResponse.class);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return wayBillResponse;

    }

    /**
     * 添加回调信息
     * @param wayBillResponse
     * @return
     */
    private CusWaybillResp InitWxCuspayRespData(WayBillResponse wayBillResponse) {
        CusWaybillResp cusWaybillResp = new CusWaybillResp();
        String WxcuspayRespSn = SysContants.wx_cuspay_resp + SnowflakeUtil.getSnowNextId();;
        cusWaybillResp.setCusWaybillRespSn(WxcuspayRespSn);
        cusWaybillResp.setMerchOrderSn(wayBillResponse.getMerchOrderSn());
        cusWaybillResp.setMerchSn(wayBillResponse.getMerchId());
        cusWaybillResp.setThirdPartyMerchCode(wayBillResponse.getThirdPartyMerchCode());
        cusWaybillResp.setNotiType(wayBillResponse.getNotiType());
        cusWaybillResp.setServiceStates(wayBillResponse.getNotiStatus());
        cusWaybillResp.setNotiInfo(wayBillResponse.getNotiInfo());
        cusWaybillResp.setLogisticsNo(wayBillResponse.getLogisticsNo());
        cusWaybillResp.setWaybillStartTime(wayBillResponse.getWaybillStartTime());
        cusWaybillResp.setWaybillEndTime(wayBillResponse.getWaybillEndTime());
        cusWaybillResp.setInvtNo(wayBillResponse.getInvtNo());
        cusWaybillResp.setClearStartTime(wayBillResponse.getClearStartTime());
        cusWaybillResp.setClearEndTime(wayBillResponse.getClearEndTime());
        cusWaybillResp.setCreateTime(new Date());
        return  cusWaybillResp;
    }
}
