package com.emato.ccnet.wx.biz.req.wxorder.order;

import com.emato.ccnet.wx.biz.CebReqAddDate;
import com.emato.ccnet.wx.service.WxOrderService;
import com.emato.ccnet.wx.support.msg.resp.ResponseMessage;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Component
@Transactional(value = "primaryTransactionManager")
public class WxOrderAddDate implements CebReqAddDate {

    private static final Logger LOGGER = LoggerFactory.getLogger(WxOrderAddDate.class);

    @Autowired
    private WxOrderService wxOrderService;
    /**
     * 微信订单初始化
     * @param list
     * @return
     */
    @Override
    public ResponseMessage addDate(List list) {
        // 微信订单的初始化
        int cusWaybill = wxOrderService.addWxOrderList(list);
        if(cusWaybill != 1){
            String info = "初始化批量微信订单记录新增失败";
            LOGGER.error("--- {}", info);
            return ResponseMessage.failed();
        }
        return ResponseMessage.success();
    }
}
