package com.emato.ccnet.wx.biz.req.wxorder.order;

import com.emato.ccnet.wx.biz.CebReqGetDate;
import com.emato.ccnet.wx.contants.CcnetContants;
import com.emato.ccnet.wx.dao.entity.wx.WxOrderDate;
import com.emato.ccnet.wx.service.WxOrderGrabService;
import com.google.common.collect.ImmutableMap;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Map;
@Component
@Transactional(value = "middleTransactionManager")
public class WxOrderGetDate implements CebReqGetDate {
    private static final Logger LOGGER = LoggerFactory.getLogger(WxOrderGetDate.class);
    @Autowired
    private WxOrderGrabService wxOrderGrabService;

    @Override
    public List<WxOrderDate> getData(Map<String, Object> param) {

        //取出待更新订单数据
        List<WxOrderDate> wxOrderDateList = wxOrderGrabService.getWxOrder(param);
        if (wxOrderDateList == null || wxOrderDateList.size() == 0) {
            return Collections.emptyList();
        }

        List<Map<String, Object>> updateList = new ArrayList<>();
        wxOrderDateList.stream().forEach(x->{
            Map<String, Object> map = ImmutableMap.of("orderId", x.getWxOrderId(), "isScan", CcnetContants.isscan.item_1.getItem());
            updateList.add(map);
        });

        //更新取出订单状态
        if (updateList.size() > 0) {
           try {
               wxOrderGrabService.updateIsScanBatch(updateList);
           }catch (Exception e){
               LOGGER.error("更新订单是否扫描的状态失败", e.getCause());
               return Collections.emptyList();
           }
        }

        return wxOrderDateList;
    }
}
