package com.emato.ccnet.wx.biz.req.wxorder.order;

import com.emato.ccnet.wx.biz.CebReqBiz;
import com.emato.ccnet.wx.contants.CcnetContants;
import com.emato.ccnet.wx.support.msg.resp.ResponseMessage;
import com.google.common.collect.ImmutableMap;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.Map;

@Component
public class WxOrderGrabBiz implements CebReqBiz {
    private static final Logger LOGGER = LoggerFactory.getLogger(WxOrderGrabBiz.class);

   @Autowired
   private WxOrderGetDate wxOrderGetDate;

   @Autowired
   private WxOrderAddDate wxOrderAddDate;

   @Value("${db.wx-send-ccnet.page-size}")
   private String limit = "20";

    /**
     * 微信订单业务入口
     * @return
     */
    @Override
    public ResponseMessage biz() {
        Map<String,Object> reqParam = ImmutableMap.of("number", Integer.valueOf(limit));
        //查询待处理数据
        List list = wxOrderGetDate.getData(reqParam);
        if (list.isEmpty()) {
            String info = "微信端没有待处理订单数据, 提前结束";
            LOGGER.error("--- {}", info);
            return ResponseMessage.failed(info);
        }

        //添加微信订单数据
        ResponseMessage responseMessage = wxOrderAddDate.addDate(list);
        if(!ResponseMessage.isSuccess(responseMessage)){
            String info = "生成微信订单数据初始化失败" + responseMessage.getMsg();
            LOGGER.error("--- {}", info);
            return ResponseMessage.failed(info);
        }

        return ResponseMessage.success();
    }

}
