package com.emato.ccnet.wx.biz.req.wxorder.ordergoods;

import com.emato.ccnet.wx.biz.CebReqAddDate;
import com.emato.ccnet.wx.service.WxOrderGoodsService;
import com.emato.ccnet.wx.support.msg.resp.ResponseMessage;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Component
@Transactional(value = "primaryTransactionManager")
public class WxOrderGoodsAddDate implements CebReqAddDate {

    private static final Logger LOGGER = LoggerFactory.getLogger(WxOrderGoodsAddDate.class);
    @Autowired
    private WxOrderGoodsService wxOrderGoodsService;

    /**
     * 微信订单的初始化
     * @param list
     * @return
     */
    @Override
    public ResponseMessage addDate(List list) {
        // 微信订单的初始化
        int cusWaybill = wxOrderGoodsService.addWxOrderGoodsList(list);
        if(cusWaybill != 1){
            String info = "初始化批量微信订单记录新增失败";
            LOGGER.error("--- {}", info);
            return ResponseMessage.failed();
        }
        return ResponseMessage.success();
    }
}
