package com.emato.ccnet.wx.biz.req.wxorder.ordergoods;

import com.emato.ccnet.wx.biz.CebReqGetDate;
import com.emato.ccnet.wx.contants.CcnetContants;
import com.emato.ccnet.wx.dao.entity.ccnet.WxOrder;
import com.emato.ccnet.wx.dao.entity.wx.WxOrderGoodsDate;
import com.emato.ccnet.wx.service.WxOrderGrabService;
import com.emato.ccnet.wx.service.WxOrderService;
import com.google.common.collect.ImmutableMap;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Map;

@Component
@Transactional(value = "middleTransactionManager")
public class WxOrderGoodsGetDate implements CebReqGetDate {

    private static final Logger LOGGER = LoggerFactory.getLogger(WxOrderGoodsGetDate.class);
    @Autowired
    private WxOrderService wxOrderService;

    @Autowired
    private WxOrderGrabService wxOrderGrabService;

    @Override
    public List getData(Map<String, Object> param) {
        //查询当前未扫描的订单
        List<WxOrder> wxOrders = wxOrderService.getWxOrder(param);
        if(wxOrders == null || wxOrders.size() <= 0){
            return Collections.emptyList();
        }
        List<String> wxOrderIdList = new ArrayList<>();
        List<Map<String, Object>> wxOrderStatus = new ArrayList<>();
        wxOrders.forEach(x->{
            wxOrderIdList.add(x.getWxOrderId());
            Map<String, Object> wxMap = ImmutableMap.of("orderSn", x.getOrderSn(),  "wxOrderDetail", CcnetContants.isscan.item_1.getItem());
            wxOrderStatus.add(wxMap);
        });

        //通过微信订单编号去查找订单详情
        List<WxOrderGoodsDate> wxOrderGoodsDates = wxOrderGrabService.getWxOrderGoods(wxOrderIdList);
        if(wxOrderGoodsDates == null || wxOrderGoodsDates.size() <= 0){
            return Collections.emptyList();
        }

        //更新订单是否扫描详情的状态
        try {
            wxOrderService.updateWxOrderStatusBatch(wxOrderStatus);
        }catch (Exception e){
            LOGGER.error("更新订单是否扫描详情的状态失败", e.getCause());
            return Collections.emptyList();
        }

        return wxOrderGoodsDates;
    }

}
