package com.emato.ccnet.wx.biz.req.wxorder.ordergoods;

import com.emato.ccnet.wx.biz.CebReqBiz;
import com.emato.ccnet.wx.contants.CcnetContants;
import com.emato.ccnet.wx.support.msg.resp.ResponseMessage;
import com.google.common.collect.ImmutableMap;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.Map;

@Component
public class WxOrderGoodsGrabBiz implements CebReqBiz {
    private static final Logger LOGGER = LoggerFactory.getLogger(WxOrderGoodsGrabBiz.class);

   @Autowired
   private WxOrderGoodsGetDate wxOrderGoodsGetDate;

   @Autowired
   private WxOrderGoodsAddDate wxOrderGoodsAddDate;

    @Value("${db.wx-send-ccnet.page-size}")
    private String limit = "20";

    /**
     * 微信订单详情业务入口
     * @return
     */
    @Override
    public ResponseMessage biz() {
        Map<String,Object> reqParam = ImmutableMap.of("number", Integer.valueOf(limit),"wxOrderDetail", CcnetContants.isscan.item_0.getItem());
        //通过订单数据orderId去查询订单详情数据
        List list = wxOrderGoodsGetDate.getData(reqParam);
        if (list.isEmpty()) {
            String info = "没有需要查询的订单详情数据, 提前结束";
            LOGGER.error("--- {}", info);
            return ResponseMessage.failed(info);
        }

        //添加订单详情数据
        ResponseMessage responseMessage = wxOrderGoodsAddDate.addDate(list);
        if(!ResponseMessage.isSuccess(responseMessage)){
            String info = "生成微信订单详情数据初始化失败" + responseMessage.getMsg();
            LOGGER.error("--- {}", info);
            return ResponseMessage.failed(info);
        }

        return ResponseMessage.success();
    }

}
