package com.emato.ccnet.wx.config.db.three;

import com.google.common.base.Joiner;
import com.google.common.collect.ImmutableList;
import org.mybatis.spring.mapper.MapperScannerConfigurer;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;


/**
 * Mybatis Mapper接口扫描配置
 *
 * @author Scott Chen
 * @date 2017/4/23
 */
@Configuration
public class ThreeMapperConfiguration {

    @Bean
    public MapperScannerConfigurer threeMapperScannerConfigurer() {
        MapperScannerConfigurer mapperScannerConfigurer = new MapperScannerConfigurer();
        //Mapper接口包
        mapperScannerConfigurer.setBasePackage(mapperPackage());
        //要使用的数据源
        mapperScannerConfigurer.setSqlSessionTemplateBeanName("threeSqlSessionTemplate");
        return mapperScannerConfigurer;
    }

    /**
     * 添加要扫描的Mapper接口包
     * 以逗号分隔的字符串
     *
     * @return
     */
    protected String mapperPackage() {
        ImmutableList.Builder<String> builder = new ImmutableList.Builder();
        builder.add("com.emato.ccnet.wx.dao.mapper.oms");
        return Joiner.on(",").join(builder.build());
    }

}
