package com.emato.ccnet.wx.contants;

public class WmContants {
    /**
     * 订单状态 (空为不限,0-待支付,1-待发货,2-已发货,3-已完成,4-已取消)
     */
    public enum orderStatuses {
        item_0(0, "待支付"),
        item_1(1, "待发货"),
        item_2(2, "已发货"),
        item_3(3, "已完成"),
        item_4(4, "已取消");

        private int item;
        private String itemName;

        orderStatuses(int item, String itemName) {
            this.item = item;
            this.itemName = itemName;
        }

        public int getItem() {
            return item;
        }

        public void setItem(int item) {
            this.item = item;
        }

        public String getItemName() {
            return itemName;
        }

        public void setItemName(String itemName) {
            this.itemName = itemName;
        }
    }

    /**
     * 渠道类型 (空为不限,0-公众号,1-小程序,2-H5,3-QQ,4-微博,5-头条,6-支付宝,7-线下)
     */
    public enum channelTypes {
        item_0("0", "公众号"),
        item_1("1", "小程序"),
        item_2("2", "H5"),
        item_3("3", "QQ"),
        item_4("4", "微博"),
        item_5("5", "头条"),
        item_6("6", "支付宝"),
        item_7("7", "线下");

        private String item;
        private String itemName;

        channelTypes(String item, String itemName) {
            this.item = item;
            this.itemName = itemName;
        }

        public String getItem() {
            return item;
        }

        public void setItem(String item) {
            this.item = item;
        }

        public String getItemName() {
            return itemName;
        }

        public void setItemName(String itemName) {
            this.itemName = itemName;
        }
    }

    /**
     * 发货状态 (空为不限,0未发货，1为部分发货，2为已发货)
     */
    public enum deliveryStatuses {
        item_0("0", "未发货"),
        item_1("1", "部分发货"),
        item_2("2", "已发货");

        private String item;
        private String itemName;

        deliveryStatuses(String item, String itemName) {
            this.item = item;
            this.itemName = itemName;
        }

        public String getItem() {
            return item;
        }

        public void setItem(String item) {
            this.item = item;
        }

        public String getItemName() {
            return itemName;
        }

        public void setItemName(String itemName) {
            this.itemName = itemName;
        }
    }
    /**
     * 支付类型 (空为不限,1-线上支付（包括微信、支付宝、银行卡、购物卡等）, 2-线下支付（包括现金、欠条等，默认是现金）, 3-混合支付（网上支付和线下支付混合）)
     */
    public enum paymentTypes {
        item_1("1", "线上支付"),
        item_2("2", "线下支付"),
        item_3("3", "混合支付");

        private String item;
        private String itemName;

        paymentTypes(String item, String itemName) {
            this.item = item;
            this.itemName = itemName;
        }

        public String getItem() {
            return item;
        }

        public void setItem(String item) {
            this.item = item;
        }

        public String getItemName() {
            return itemName;
        }

        public void setItemName(String itemName) {
            this.itemName = itemName;
        }
    }
    /**
     * 支付方式 (空为不限,1-支付宝,2-微信,3-银行卡,4-现金,5-货到付款,6-无需支付)
     */
    public enum paymentMethods {
        item_1("1", "支付宝"),
        item_2("2", "微信"),
        item_3("3", "银行卡"),
        item_4("4", "现金"),
        item_5("5", "货到付款"),
        item_6("6", "无需支付");

        private String item;
        private String itemName;

        paymentMethods(String item, String itemName) {
            this.item = item;
            this.itemName = itemName;
        }

        public String getItem() {
            return item;
        }

        public void setItem(String item) {
            this.item = item;
        }

        public String getItemName() {
            return itemName;
        }

        public void setItemName(String itemName) {
            this.itemName = itemName;
        }
    }
    /**
     * 配送类型 (空为不限,1-物流配送(走快递发货流程),2-同城限时达（走即时物流流程）,3-到店自提（走自提流程）)
     */
    public enum deliveryTypes {
        item_1("1", "物流配送"),
        item_2("2", "同城限时达"),
        item_3("3", "到店自提");

        private String item;
        private String itemName;

        deliveryTypes(String item, String itemName) {
            this.item = item;
            this.itemName = itemName;
        }

        public String getItem() {
            return item;
        }

        public void setItem(String item) {
            this.item = item;
        }

        public String getItemName() {
            return itemName;
        }

        public void setItemName(String itemName) {
            this.itemName = itemName;
        }
    }
    /**
     * 订单标记 (空为不限,等级1到5)
     */
    public enum flagRanks {
        item_1("1", "等级1"),
        item_2("2", "等级2"),
        item_3("3", "等级3"),
        item_4("4", "等级4"),
        item_5("5", "等级5");

        private String item;
        private String itemName;

        flagRanks(String item, String itemName) {
            this.item = item;
            this.itemName = itemName;
        }

        public String getItem() {
            return item;
        }

        public void setItem(String item) {
            this.item = item;
        }

        public String getItemName() {
            return itemName;
        }

        public void setItemName(String itemName) {
            this.itemName = itemName;
        }
    }
    /**
     * 业务类型 (空为不限,0-普通,3-限时折扣,4-砍价, 5-拼团)
     */
    public enum bizTypes {
        item_0("0", "普通"),
        item_3("3", "限时折扣"),
        item_4("4", "砍价"),
        item_5("5", "拼团");

        private String item;
        private String itemName;

        bizTypes(String item, String itemName) {
            this.item = item;
            this.itemName = itemName;
        }

        public String getItem() {
            return item;
        }

        public void setItem(String item) {
            this.item = item;
        }

        public String getItemName() {
            return itemName;
        }

        public void setItemName(String itemName) {
            this.itemName = itemName;
        }
    }
    /**
     * 各单证的发送状态(0-待发送,1-发送中,2-成功,3--失败)
     */
    public enum wmStatuses {
        item_0("0", "待发送"),
        item_1("1", "发送中"),
        item_2("2", "成功"),
        item_3("3", "失败");

        private String item;
        private String itemName;

        wmStatuses(String item, String itemName) {
            this.item = item;
            this.itemName = itemName;
        }

        public String getItem() {
            return item;
        }

        public void setItem(String item) {
            this.item = item;
        }

        public String getItemName() {
            return itemName;
        }

        public void setItemName(String itemName) {
            this.itemName = itemName;
        }
    }

}
