package com.emato.ccnet.wx.controller;

import com.emato.ccnet.wx.biz.req.order.csp.Ceb311CustiomsResponse;
import com.emato.ccnet.wx.biz.req.order.csp.Ceb311OrderBiz;
import com.emato.ccnet.wx.manager.result.Result;
import com.emato.ccnet.wx.support.msg.resp.ResponseMessage;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

@RestController
public class CusOrderController {
    private static final Logger LOGGER = LoggerFactory.getLogger(CusOrderController.class);

    @Autowired
    private Ceb311OrderBiz ceb311OrderBiz;
    @Autowired
    private Ceb311CustiomsResponse ceb311CustiomsResponse;

    @RequestMapping("/wx/cusOrderBill")
    public ResponseMessage cusOrderBill() {
        LOGGER.info("---------- 电子订单运单数据开始 ----------------------------------------");
        ResponseMessage result = ceb311OrderBiz.biz();
        LOGGER.info("---------- 电子订单运单数据结束 ----------------------------------------");
        return result;
    }

    @RequestMapping(value = "/wx/cusOrderBillResp", method = RequestMethod.POST)
    public Result cusOrderBillResp(@RequestBody Result result) {
        LOGGER.info("---------- 电子订单运单数据开始 ----------------------------------------");
        int i = ceb311CustiomsResponse.biz(result);
        Result re = null;
        if(i == 1){
            re = Result.success("error");
        } else if(i == 2){
            re = Result.success("success");
        } else {
            re = Result.error("error");
        }
        LOGGER.info(re.toString());
        return re;
    }

}
