package com.emato.ccnet.wx.controller;

import com.emato.ccnet.wx.biz.req.waybill.oms.Ceb511OmsWayBiz;
import com.emato.ccnet.wx.biz.req.waybill.oms.Ceb511Response;
import com.emato.ccnet.wx.manager.result.Result;
import com.emato.ccnet.wx.support.msg.resp.ResponseMessage;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

@RestController
public class CusWaybillController {
    private static final Logger LOGGER = LoggerFactory.getLogger(CusWaybillController.class);

    @Autowired
    private Ceb511OmsWayBiz ceb511OmsWayBiz;

    @Autowired
    private Ceb511Response ceb511Response;

    @RequestMapping("/wx/cusWaybill")
    public ResponseMessage cusWaybill() {
        LOGGER.info("---------- 支付单数据开始 ----------------------------------------");
        ResponseMessage result = ceb511OmsWayBiz.biz();
        LOGGER.info("---------- 支付单数据结束 ----------------------------------------");
        return result;
    }

    @RequestMapping(value = "/wx/cusWaybillResponse", method = RequestMethod.POST)
    public ResponseMessage cusWaybillResponse(@RequestBody Result result) {
        LOGGER.info("---------- 支付单数据开始 ----------------------------------------");
        ResponseMessage responseMessage = ceb511Response.biz(result);
        LOGGER.info("---------- 支付单数据结束 ----------------------------------------");
        return responseMessage;
    }

}
