package com.emato.ccnet.wx.dao.mapper.ccnet;

import com.emato.ccnet.wx.dao.entity.ccnet.CusOrderStatus;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

@Repository
public interface CusOrderStatusMapper {
    int deleteByPrimaryKey(String cusOrderStatusSn);

    int insertSelective(CusOrderStatus record);

    CusOrderStatus selectByPrimaryKey(String cusOrderStatusSn);

    int updateByPrimaryKeySelective(CusOrderStatus record);

    /**
     * 批量插入海关电子订单状态表
     * @param cusOrderStatues
     * @return
     */
    int insertCusOrderStatusItemBatch(List<CusOrderStatus> cusOrderStatues);

    /**
     * 通过电子订单编号查找电子订单
     * @param param
     * @return
     */
    CusOrderStatus findCusOrderStatus(Map<String, Object> param);

    /**
     * 单个更新电子订单状态表
     * @param cusOrderStatus
     * @return
     */
    int updateCusOrderStatus(CusOrderStatus cusOrderStatus);

    /**
     * 批量更新海关电子订单状态表状态
     * @param list
     * @return
     */
    int updateCusOrderStatusBatch(List list);

    CusOrderStatus findCusOrderStatusByCusOrderSn(String cusOrderSn);

    int updateCusOrderStatusItemBatch(List<CusOrderStatus> cusOrderStatues);
}