package com.emato.ccnet.wx.dto.ccnetdto;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * 电子订单数据
 */
public class OrderBill implements Serializable {

    private static final long serialVersionUID = 1430859128928892774L;

    /**
     * 商户订单编号/订单编号
     */
    private String orderNo;

    private String orderSn;

    /**
     * 第三方商户代码
     */
    private String sellerId;

    /**
     * 第三方商户名称
     */
    private String sellerName;

    /**
     * 下单时间
     */
    private Date createTime;

    /**
     * 支付平台交易号
     */
    private String tradeNo;

    /**
     * 商品价格
     */
    private BigDecimal realAmount;

    /**
     * 订购人注册号
     */
    private String userId;

    /**
     * 订购人姓名
     */
    private String trueName;

    /**
     * 订购人证件类型
     */
    private String idType;

    /**
     * 订购人证件号码
     */
    private String idCode;

    /**
     * 收货人名称
     */
    private String acceptName;

    /**
     * 收货人电话
     */
    private String mobile;

    /**
     * 收货人地址
     */
    private String address;

    /**
     * 商品原价格
     */
    private BigDecimal costPrice;

    /**
     * 运杂费
     */
    private BigDecimal freight;

    /**
     * 非现金抵扣金额
     */
    private BigDecimal discount;

    public String getOrderSn() {
        return orderSn;
    }

    public void setOrderSn(String orderSn) {
        this.orderSn = orderSn;
    }

    public BigDecimal getCostPrice() {
        return costPrice;
    }

    public void setCostPrice(BigDecimal costPrice) {
        this.costPrice = costPrice;
    }

    public BigDecimal getFreight() {
        return freight;
    }

    public void setFreight(BigDecimal freight) {
        this.freight = freight;
    }

    public BigDecimal getDiscount() {
        return discount;
    }

    public void setDiscount(BigDecimal discount) {
        this.discount = discount;
    }

    public String getOrderNo() {
        return orderNo;
    }

    public void setOrderNo(String orderNo) {
        this.orderNo = orderNo;
    }

    public String getSellerId() {
        return sellerId;
    }

    public void setSellerId(String sellerId) {
        this.sellerId = sellerId;
    }

    public String getSellerName() {
        return sellerName;
    }

    public void setSellerName(String sellerName) {
        this.sellerName = sellerName;
    }

    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    public String getTradeNo() {
        return tradeNo;
    }

    public void setTradeNo(String tradeNo) {
        this.tradeNo = tradeNo;
    }

    public BigDecimal getRealAmount() {
        return realAmount;
    }

    public void setRealAmount(BigDecimal realAmount) {
        this.realAmount = realAmount;
    }

    public String getUserId() {
        return userId;
    }

    public void setUserId(String userId) {
        this.userId = userId;
    }

    public String getTrueName() {
        return trueName;
    }

    public void setTrueName(String trueName) {
        this.trueName = trueName;
    }

    public String getIdType() {
        return idType;
    }

    public void setIdType(String idType) {
        this.idType = idType;
    }

    public String getIdCode() {
        return idCode;
    }

    public void setIdCode(String idCode) {
        this.idCode = idCode;
    }

    public String getAcceptName() {
        return acceptName;
    }

    public void setAcceptName(String acceptName) {
        this.acceptName = acceptName;
    }

    public String getMobile() {
        return mobile;
    }

    public void setMobile(String mobile) {
        this.mobile = mobile;
    }

    public String getAddress() {
        return address;
    }

    public void setAddress(String address) {
        this.address = address;
    }
}
