package com.emato.ccnet.wx.manager.redis.jedis.cluster.config;

import com.emato.ccnet.wx.manager.redis.jedis.cluster.mgt.JedisClusterManager;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import redis.clients.jedis.JedisCluster;

/**
 * Spring Boot 方式生成 JedisCluster
 * @author Scott Chen
 * @since 1.0
 * 2018-01-06 16:07
 */
@Configuration
public class JedisClusterConfiguration {

    @Bean
    @ConfigurationProperties(prefix = "redis.jedis-cluster")
    public JedisClusterProperties jedisClusterProperties() {
        return new JedisClusterProperties();
    }

    @Bean
    public JedisCluster jedisCluster() {
        return jedisClusterProperties().initializeJedisClusterBuilder().build();
    }

    @Bean
    public JedisClusterManager jedisClusterManager() {
        return JedisClusterManager.instance();
    }

}
