package com.emato.ccnet.wx.manager.redis.jedis.cluster.config;

import org.apache.commons.pool2.impl.GenericObjectPoolConfig;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.io.Serializable;
import java.util.List;

/**
 * @author Scott Chen
 * @since 1.0
 * 2018-01-06 16:12
 */
public class JedisClusterProperties implements Serializable {
    private static final Logger logger = LoggerFactory.getLogger(JedisClusterProperties.class);
    private static final long serialVersionUID = -1621540040447290980L;

    // 配置文件中主机节点
    private List<RedisClusterHostList> redisClusterHostList;
    private int connectionTimeout;
    private int soTimeout;
    private int maxAttempts;
    private String password;
    private GenericObjectPoolConfig poolConfig;

    public JedisClusterBuilder initializeJedisClusterBuilder() {
        return JedisClusterBuilder.create()
                .buildHost(this.redisClusterHostList)
                .setConnectionTimeout(this.connectionTimeout)
                .setSoTimeout(this.soTimeout)
                .setMaxAttempts(this.maxAttempts)
                .setPassword(this.password)
                .setPoolConfig(this.poolConfig);
    }

    public List<RedisClusterHostList> getRedisClusterHostList() {
        return redisClusterHostList;
    }

    public void setRedisClusterHostList(List<RedisClusterHostList> redisClusterHostList) {
        this.redisClusterHostList = redisClusterHostList;
    }

    public int getConnectionTimeout() {
        return connectionTimeout;
    }

    public void setConnectionTimeout(int connectionTimeout) {
        this.connectionTimeout = connectionTimeout;
    }

    public int getSoTimeout() {
        return soTimeout;
    }

    public void setSoTimeout(int soTimeout) {
        this.soTimeout = soTimeout;
    }

    public int getMaxAttempts() {
        return maxAttempts;
    }

    public void setMaxAttempts(int maxAttempts) {
        this.maxAttempts = maxAttempts;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public GenericObjectPoolConfig getPoolConfig() {
        return poolConfig;
    }

    public void setPoolConfig(GenericObjectPoolConfig poolConfig) {
        this.poolConfig = poolConfig;
    }

}
