package com.emato.ccnet.wx.manager.snow;


import com.emato.ccnet.wx.util.SpringContextSupport;

/**
 * @author Scott Chen
 * @since 1.0
 * 2018-01-08 11:19
 */
public class SnowflakeUtil {

    private static final ThreadLocal<SnowflakeIdWorker> snowflakeIdWorkerThreadLocal = new ThreadLocal<>();

    private SnowflakeUtil() {
        throw new RuntimeException("Illegal instance SnowflakeUtil");
    }

    private static SnowflakeIdWorker snowWorkerInstance() {
        SnowflakeIdWorker snowflakeIdWorker = snowflakeIdWorkerThreadLocal.get();
        if (snowflakeIdWorker == null) {
            snowflakeIdWorker = SpringContextSupport.getBean("snowflakeIdWorker");
            snowflakeIdWorkerThreadLocal.set(snowflakeIdWorker);
        }
        return snowflakeIdWorker;
    }

    public static long getSnowNextId() {
        return snowWorkerInstance().nextId();
    }

}
