package com.emato.ccnet.wx.rabbitMq.rabbitImpl;

import com.emato.ccnet.wx.biz.req.order.csp.Ceb311CustiomsResponse;
import com.emato.ccnet.wx.manager.result.Result;
import com.emato.ccnet.wx.rabbitMq.RabbitMqConfig;
import com.google.gson.Gson;
import com.rabbitmq.client.Channel;
import org.springframework.amqp.core.AcknowledgeMode;
import org.springframework.amqp.core.Message;
import org.springframework.amqp.rabbit.core.ChannelAwareMessageListener;
import org.springframework.amqp.rabbit.listener.SimpleMessageListenerContainer;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Bean;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.Map;

@Component("ceb311OrderListenerImpl")
public class Ceb311OrderListenerImpl extends RabbitMqConfig {
    @Autowired
    private Ceb311CustiomsResponse ceb311CustiomsResponse;

    /**
     * 队列消息监听
     *
     * @return
     */
    @Bean
    public SimpleMessageListenerContainer goodsCEB201MessageContainer() {
        SimpleMessageListenerContainer container = new SimpleMessageListenerContainer(connectionFactory());
        container.setQueues(super.ccnetGainDeclareCspQueue());
        container.setExposeListenerChannel(true);
        container.setMaxConcurrentConsumers(1);
        container.setConcurrentConsumers(1);
        container.setAcknowledgeMode(AcknowledgeMode.MANUAL); //设置确认模式手工确认
        container.setMessageListener(new ChannelAwareMessageListener() {
            public void onMessage(Message message, Channel channel) throws Exception {
                Gson gson = new Gson();
                byte[] body = message.getBody();
                String outMqData = new String(body);
                logger.info("商品备案收到消息:" + outMqData);
                try {
                    Result result = gson.fromJson(outMqData, Result.class);
                    Map<String, Object> map = new HashMap<String, Object>();
                    map.put("resultData", result);
                    //ceb311CustiomsResponse.req(map);
                } catch (Exception e) {
                    logger.error("商品备案消费发生异常", e);
                } finally {
                    channel.basicAck(message.getMessageProperties().getDeliveryTag(), false); //确认消息成功消费
                }
            }
        });
        return container;
    }

}
