package com.emato.ccnet.wx.service.impl;

import com.emato.ccnet.wx.dao.entity.ccnet.CusOrderGoods;
import com.emato.ccnet.wx.dao.mapper.ccnet.CusOrderGoodsMapper;
import com.emato.ccnet.wx.service.CusOrderGoodsService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

@Service("cusOrderGoodsService")
public class CusOrderGoodsServiceImpl implements CusOrderGoodsService {
    @Autowired
    private CusOrderGoodsMapper cusOrderGoodsMapper;

    private static final Logger logger = LoggerFactory.getLogger(CusOrderGoodsServiceImpl.class);

    @Override
    public CusOrderGoods add(CusOrderGoods record) {
        record.setCreateTime(new Date());
        if(this.cusOrderGoodsMapper.insertSelective(record)==1) {
            	return record; 
        }
        return null;
    }

    @Override
    public boolean delete(String cusOrderGoodsSn) {
        return this.cusOrderGoodsMapper.deleteByPrimaryKey(cusOrderGoodsSn)==1;
    }

    @Override
    public CusOrderGoods update(CusOrderGoods record) {
        if(this.cusOrderGoodsMapper.updateByPrimaryKeySelective(record)==1) {
            	return record;
        }
        return null;
    }

    @Override
    public CusOrderGoods get(String cusOrderGoodsSn) {
        return this.cusOrderGoodsMapper.selectByPrimaryKey(cusOrderGoodsSn);
    }

    /**
     * 通过电子订单内部编号查找电子订单商品
     * @param cusOrderSn
     * @return
     */
    @Override
    public List<CusOrderGoods> findCusOrderGoodsByCusOrderSn(String cusOrderSn) {
        return cusOrderGoodsMapper.findCusOrderGoodsByCusOrderSn(cusOrderSn);
    }
}