package com.emato.ccnet.wx.service.impl;

import com.emato.ccnet.wx.contants.Contants;
import com.emato.ccnet.wx.dao.entity.ccnet.CusOrderResp;
import com.emato.ccnet.wx.dao.mapper.ccnet.CusOrderRespMapper;
import com.emato.ccnet.wx.dto.ccnetdto.*;
import com.emato.ccnet.wx.manager.snow.SnowflakeUtil;
import com.emato.ccnet.wx.service.CusOrderRespService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;

@Service("cusOrderRespService")
public class CusOrderRespServiceImpl implements CusOrderRespService {
    @Autowired
    private CusOrderRespMapper cusOrderRespMapper;

    private static final Logger logger = LoggerFactory.getLogger(CusOrderRespServiceImpl.class);

    @Override
    public CusOrderResp add(CusOrderResp record) {
        record.setCreateTime(new Date());
        if(this.cusOrderRespMapper.insertSelective(record)==1) {
            	return record; 
        }
        return null;
    }

    @Override
    public boolean delete(String cusOrderRespSn) {
        return this.cusOrderRespMapper.deleteByPrimaryKey(cusOrderRespSn)==1;
    }

    @Override
    public CusOrderResp update(CusOrderResp record) {
        if(this.cusOrderRespMapper.updateByPrimaryKeySelective(record)==1) {
            	return record;
        }
        return null;
    }

    @Override
    public CusOrderResp get(String cusOrderRespSn) {
        return this.cusOrderRespMapper.selectByPrimaryKey(cusOrderRespSn);
    }

    /**
     * 添加电子订单海关的回执数据
     * @param orderCustiomsResponse
     * @return
     */
    @Override
    public CusOrderResp insertCusOrderRespByCustioms(OrderCustiomsResponse orderCustiomsResponse, String cusOrderSn) {
        CusOrderResp cusOrderResp = new CusOrderResp();
        CiqResultStatusDto ciqResultStatusDto = orderCustiomsResponse.getCiqResultStatusDto();
        CusResultStatusDto cusResultStatusDto = orderCustiomsResponse.getCusResultStatusDto();
        EportResultStatusDto eportResultStatusDto = orderCustiomsResponse.getEportResultStatusDto();
        OrderDto orderRequest = orderCustiomsResponse.getClsOrderDto();
        String cusOrderRespSn = Contants.WMSH + SnowflakeUtil.getSnowNextId();
        cusOrderResp.setCusOrderRespSn(cusOrderRespSn);
        cusOrderResp.setCusOrderSn(cusOrderSn);
        cusOrderResp.setOrderSn(orderRequest.getOrderSn());
        cusOrderResp.setMerchOrderSn(orderRequest.getMerchOrderSn());
        cusOrderResp.setMerchSn(orderRequest.getMerchSn());
        cusOrderResp.setMerchName(orderRequest.getMerchName());
        cusOrderResp.setPlatSn(orderRequest.getPlatSn());
        cusOrderResp.setPlatName(orderRequest.getPlatName());
        cusOrderResp.setThirdPartyMerchCode(orderRequest.getThirdPartyMerchCode());
        cusOrderResp.setThirdPartyMerchName(orderRequest.getThirdPartyMerchName());
        cusOrderResp.setBizInfoCode(orderCustiomsResponse.getCode());
        cusOrderResp.setPlatRespCode(eportResultStatusDto == null ? null : eportResultStatusDto.getCode());
        cusOrderResp.setPlatRespDesc(eportResultStatusDto == null ? null : eportResultStatusDto.getMsg());
        cusOrderResp.setCusRespCode(cusResultStatusDto == null ? null : cusResultStatusDto.getCode());
        cusOrderResp.setCusRespDesc(cusResultStatusDto == null ? null : cusResultStatusDto.getMsg());
        cusOrderResp.setCiqRespCode(ciqResultStatusDto == null ? null : ciqResultStatusDto.getCode());
        cusOrderResp.setCiqRespDesc(ciqResultStatusDto == null ? null : ciqResultStatusDto.getMsg());
        cusOrderResp.setCreaterSn(Contants.CREATER_NUMBER);
        cusOrderResp.setCreateTime(new Date());

        if(cusOrderRespMapper.insertSelective(cusOrderResp) != 1){
            return null;
        }
        return cusOrderResp;
    }
}