package com.emato.ccnet.wx.service.impl;

import com.emato.ccnet.wx.dao.entity.ccnet.CusOrderStatus;
import com.emato.ccnet.wx.dao.mapper.ccnet.CusOrderStatusMapper;
import com.emato.ccnet.wx.service.CusOrderStatusService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;
import java.util.Map;

@Service("cusOrderStatusService")
public class CusOrderStatusServiceImpl implements CusOrderStatusService {
    @Autowired
    private CusOrderStatusMapper cusOrderStatusMapper;

    private static final Logger logger = LoggerFactory.getLogger(CusOrderStatusServiceImpl.class);

    @Override
    public CusOrderStatus add(CusOrderStatus record) {
        record.setCreateTime(new Date());
        if(this.cusOrderStatusMapper.insertSelective(record)==1) {
            	return record; 
        }
        return null;
    }

    @Override
    public boolean delete(String cusOrderStatusSn) {
        return this.cusOrderStatusMapper.deleteByPrimaryKey(cusOrderStatusSn)==1;
    }

    @Override
    public CusOrderStatus update(CusOrderStatus record) {
        if(this.cusOrderStatusMapper.updateByPrimaryKeySelective(record)==1) {
            	return record;
        }
        return null;
    }

    @Override
    public CusOrderStatus get(String cusOrderStatusSn) {
        return this.cusOrderStatusMapper.selectByPrimaryKey(cusOrderStatusSn);
    }

    /**
     * 通过订单编号查找电子订单表
     * @param param
     * @return
     */
    @Override
    public CusOrderStatus findCusOrderStatus(Map<String, Object> param) {
        return cusOrderStatusMapper.findCusOrderStatus(param);
    }

    /**
     * 单个更新电子订单状态表
     * @param cusOrderStatus
     * @return
     */
    @Override
    public int updateCusOrderStatus(CusOrderStatus cusOrderStatus) {
        return cusOrderStatusMapper.updateCusOrderStatus(cusOrderStatus);
    }

    /**
     * 批量更新电子订单状态
     * @param list
     * @return
     */
    @Override
    public int updateCusOrderStatusBatch(List list) {
        return cusOrderStatusMapper.updateCusOrderStatusBatch(list);
    }
}