package com.emato.ccnet.wx.service.impl;

import com.emato.ccnet.wx.dao.entity.ccnet.CusWaybillGoods;
import com.emato.ccnet.wx.dao.mapper.ccnet.CusWaybillGoodsMapper;
import com.emato.ccnet.wx.service.CusWaybillGoodsService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

@Service("cusWaybillGoodsService")
public class CusWaybillGoodsServiceImpl implements CusWaybillGoodsService {
    @Autowired
    private CusWaybillGoodsMapper cusWaybillGoodsMapper;

    private static final Logger logger = LoggerFactory.getLogger(CusWaybillGoodsServiceImpl.class);

    @Override
    public CusWaybillGoods add(CusWaybillGoods record) {
        record.setCreateTime(new Date());
        if(this.cusWaybillGoodsMapper.insertSelective(record)==1) {
            	return record; 
        }
        return null;
    }

    @Override
    public boolean delete(String cusWaybillGoodsSn) {
        return this.cusWaybillGoodsMapper.deleteByPrimaryKey(cusWaybillGoodsSn)==1;
    }

    @Override
    public CusWaybillGoods update(CusWaybillGoods record) {
        if(this.cusWaybillGoodsMapper.updateByPrimaryKeySelective(record)==1) {
            	return record;
        }
        return null;
    }

    @Override
    public CusWaybillGoods get(String cusWaybillGoodsSn) {
        return this.cusWaybillGoodsMapper.selectByPrimaryKey(cusWaybillGoodsSn);
    }

    /**
     * 通过商户订单编号查找运单商品
     * @param merchOrderId
     * @return
     */
    @Override
    public List<CusWaybillGoods> findCusWaybillGoodsByOrderId(String merchOrderId) {
        return cusWaybillGoodsMapper.findCusWaybillGoodsByOrderId(merchOrderId);
    }
}