package com.emato.ccnet.wx.service.impl;

import com.emato.ccnet.wx.config.Merchant;
import com.emato.ccnet.wx.contants.Contants;
import com.emato.ccnet.wx.dao.entity.ccnet.CusWaybillResp;
import com.emato.ccnet.wx.dao.mapper.ccnet.CusWaybillRespMapper;
import com.emato.ccnet.wx.dto.ccnetdto.BondedStockMerchantOrder;
import com.emato.ccnet.wx.manager.snow.SnowflakeUtil;
import com.emato.ccnet.wx.service.CusWaybillRespService;
import com.emato.ccnet.wx.support.msg.resp.ResponseMessage;
import com.google.gson.Gson;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

@Service("cusWaybillRespService")
public class CusWaybillRespServiceImpl implements CusWaybillRespService {
    @Autowired
    private CusWaybillRespMapper cusWaybillRespMapper;
    @Autowired
    private Merchant merchant;

    private static final Logger logger = LoggerFactory.getLogger(CusWaybillRespServiceImpl.class);

    @Override
    public CusWaybillResp add(CusWaybillResp record) {
        record.setCreateTime(new Date());
        if(this.cusWaybillRespMapper.insertSelective(record)==1) {
            	return record; 
        }
        return null;
    }

    @Override
    public boolean delete(String cusWaybillRespSn) {
        return this.cusWaybillRespMapper.deleteByPrimaryKey(cusWaybillRespSn)==1;
    }

    @Override
    public CusWaybillResp update(CusWaybillResp record) {
        if(this.cusWaybillRespMapper.updateByPrimaryKeySelective(record)==1) {
            	return record;
        }
        return null;
    }

    @Override
    public CusWaybillResp get(String cusWaybillRespSn) {
        return this.cusWaybillRespMapper.selectByPrimaryKey(cusWaybillRespSn);
    }

    /**
     * 新增oms响应数据
     * @param result
     * @return
     */
    @Override
    public int insertWaybillResp(ResponseMessage result, String cusWaybillSn) {
        Gson gson = new Gson();
        CusWaybillResp cusWaybillResp = new CusWaybillResp();
        String cusWaybillRespSn = Contants.WMSH + SnowflakeUtil.getSnowNextId();
        cusWaybillResp.setCusWaybillRespSn(cusWaybillRespSn);
        cusWaybillResp.setCusWaybillSn(cusWaybillSn);
        cusWaybillResp.setPlatName(merchant.getPlatSn());

        if(ResponseMessage.isSuccess(result)){
            List<BondedStockMerchantOrder> BondedStockMerchantOrderList = result.getData().getRows();
            if(BondedStockMerchantOrderList != null){
                BondedStockMerchantOrder bondedStockMerchantOrder = gson.fromJson(gson.toJson(BondedStockMerchantOrderList.get(0)), BondedStockMerchantOrder.class);
                if(bondedStockMerchantOrder != null){
                    cusWaybillResp.setMerchOrderSn(bondedStockMerchantOrder.getMerchOrderId());
                    cusWaybillResp.setMerchSn(bondedStockMerchantOrder.getMerchId());
                    cusWaybillResp.setMerchName(bondedStockMerchantOrder.getMerchName());
                    cusWaybillResp.setPlatSn(bondedStockMerchantOrder.getPlatSn());
                    cusWaybillResp.setThirdPartyMerchCode(bondedStockMerchantOrder.getThirdPartyMerchCode());
                    cusWaybillResp.setThirdPartyMerchName(bondedStockMerchantOrder.getThirdPartyMerchName());
                }
            }
        }

        cusWaybillResp.setBizInfoCode(result.getCode());
        cusWaybillResp.setBizInfoDesc(result.getMsg());
        cusWaybillResp.setCreaterSn(Contants.CREATER_NUMBER);
        cusWaybillResp.setCreateTime(new Date());
        if(cusWaybillRespMapper.insertSelective(cusWaybillResp) <= 0){
            return 0;
        }
        return 1;
    }
}