package com.emato.ccnet.wx.service.impl;

import com.emato.ccnet.wx.dao.entity.ccnet.CusWaybillStatus;
import com.emato.ccnet.wx.dao.mapper.ccnet.CusWaybillStatusMapper;
import com.emato.ccnet.wx.service.CusWaybillStatusService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;
import java.util.Map;

@Service("cusWaybillStatusService")
public class CusWaybillStatusServiceImpl implements CusWaybillStatusService {
    @Autowired
    private CusWaybillStatusMapper cusWaybillStatusMapper;

    private static final Logger logger = LoggerFactory.getLogger(CusWaybillStatusServiceImpl.class);

    @Override
    public CusWaybillStatus add(CusWaybillStatus record) {
        record.setCreateTime(new Date());
        if(this.cusWaybillStatusMapper.insertSelective(record)==1) {
            	return record; 
        }
        return null;
    }

    @Override
    public boolean delete(String cusWaybillStatusSn) {
        return this.cusWaybillStatusMapper.deleteByPrimaryKey(cusWaybillStatusSn)==1;
    }

    @Override
    public CusWaybillStatus update(CusWaybillStatus record) {
        if(this.cusWaybillStatusMapper.updateByPrimaryKeySelective(record)==1) {
            	return record;
        }
        return null;
    }

    @Override
    public CusWaybillStatus get(String cusWaybillStatusSn) {
        return this.cusWaybillStatusMapper.selectByPrimaryKey(cusWaybillStatusSn);
    }

    /**
     * 批量更新状态
     * @param list
     * @return
     */
    @Override
    public int updateCusWaybillStatusBatch(List list) {
        return cusWaybillStatusMapper.updateCusWaybillStatusBatch(list);
    }

    /**
     * 通过状态和内部订单编号查找海关运单数据
     * @param map
     * @return
     */
    @Override
    public CusWaybillStatus findCusWaybillStatus(Map<String, Object> map) {
        return cusWaybillStatusMapper.findCusWaybillStatus(map);
    }

    /**
     * 更新海关运单数据
     * @param cusWaybillStatus
     * @return
     */
    @Override
    public int updateCusWaybillStatus(CusWaybillStatus cusWaybillStatus) {
        return cusWaybillStatusMapper.updateCusWaybillStatus(cusWaybillStatus);
    }
}