package com.emato.ccnet.wx.service.impl;

import com.emato.ccnet.wx.dao.entity.ccnet.WxCuspayStatus;
import com.emato.ccnet.wx.dao.mapper.ccnet.WxCuspayStatusMapper;
import com.emato.ccnet.wx.service.WxCuspayStatusService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;
import java.util.Map;

@Service("wxCuspayStatusService")
public class WxCuspayStatusServiceImpl implements WxCuspayStatusService {
    @Autowired
    private WxCuspayStatusMapper wxCuspayStatusMapper;

    private static final Logger logger = LoggerFactory.getLogger(WxCuspayStatusServiceImpl.class);

    @Override
    public WxCuspayStatus add(WxCuspayStatus record) {
        record.setCreateTime(new Date());
        if(this.wxCuspayStatusMapper.insertSelective(record)==1) {
            	return record; 
        }
        return null;
    }

    @Override
    public boolean delete(String cusOrderStatusSn) {
        return this.wxCuspayStatusMapper.deleteByPrimaryKey(cusOrderStatusSn)==1;
    }

    @Override
    public WxCuspayStatus update(WxCuspayStatus record) {
        if(this.wxCuspayStatusMapper.updateByPrimaryKeySelective(record)==1) {
            	return record;
        }
        return null;
    }

    @Override
    public WxCuspayStatus get(String cusOrderStatusSn) {
        return this.wxCuspayStatusMapper.selectByPrimaryKey(cusOrderStatusSn);
    }
    @Override
    public WxCuspayStatus findWxCuspayStatus(Map<String, Object> reqParam) {
        return this.wxCuspayStatusMapper.findWxCuspayStatus(reqParam);
    }

    @Override
    public int updatewxCuspayStatusServiceBatch(List<Map<String, Object>> sucs) {
        return this.wxCuspayStatusMapper.updatewxCuspayStatusServiceBatch(sucs);
    }
}